﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using System;

public class FMsound : MonoBehaviour
{
    int objno = 0;
    rtcmixmain RTcmix;
    private bool did_start = false;

    private void Awake()
    {
        // find the RTcmixmain object with the RTcmix function definitions
        RTcmix = GameObject.Find("RTcmixmain").GetComponent<rtcmixmain>();
    }


    // Use this for initialization
    void Start()
    {
        // initialize RTcmix
        RTcmix.initRTcmix(objno);

        String score = "wave = maketable(\"wave\", 1000, \"sine\") " +
            "car = makeconnection(\"inlet\", 1, 150) " +
            "mod = makeconnection(\"inlet\", 2, 170) " +
            "index = makeconnection(\"inlet\", 3, 3) " +
            "FMINST(0, 9999, 20000, car, mod, index, index, 0.5, wave, 1) ";

        // send a note using the WAVETABLE() instrument
        RTcmix.SendScore(score, objno);

        did_start = true;
    }

    public void setFMparams(float cfreq, float mfreq, float dex) {
        RTcmix.setpfieldRTcmix(1, cfreq, objno);
        RTcmix.setpfieldRTcmix(2, mfreq, objno);
        RTcmix.setpfieldRTcmix(3, dex, objno);
    }

    // Update is called once per frame
    void Update()
    {
    }


    void OnAudioFilterRead(float[] data, int channels)
    {
        if (!did_start) return;

        // compute sound samples
        RTcmix.runRTcmix(data, objno, 0);
    }


    void OnApplicationQuit()
    {
        did_start = false;
        RTcmix = null;
    }
}
